# Code generated by smithy-python-codegen DO NOT EDIT.

from dataclasses import dataclass
from enum import StrEnum
from typing import Union


@dataclass(kw_only=True)
class ValidationExceptionField:
    """Describes one specific validation failure for an input member.

    :param path: A JSONPointer expression to the structure member whose value failed
    to satisfy the modeled constraints.
    :param message: A detailed description of the validation failure.
    """

    path: str

    message: str

@dataclass(kw_only=True)
class DeleteItemInput:

    database_id: str | None = None
    key: str | None = None

@dataclass
class DeleteItemOutput:
    pass

@dataclass
class EmbeddingInputText:

    value: str

@dataclass
class EmbeddingInputImage:

    value: bytes | bytearray

@dataclass
class EmbeddingInputUnknown:
    """Represents an unknown variant.

    If you receive this value, you will need to update your library to receive the
    parsed value.

    This value may not be deliberately sent.
    """

    tag: str

EmbeddingInput = Union[EmbeddingInputText, EmbeddingInputImage, EmbeddingInputUnknown]

class EmbeddingModel(StrEnum):
    ALL_MINILM_L6_V2 = "ALL_MINILM_L6_V2"
    CLIP_VIT_BASE_PATH32 = "CLIP_VIT_BASE_PATH32"

@dataclass(kw_only=True)
class EmbedInput:

    database_id: str | None = None
    model: str | None = None
    input: EmbeddingInput | None = None

@dataclass(kw_only=True)
class EmbedOutput:

    vector: list[float]

    consumed_embedding_units: int | None = None

@dataclass(kw_only=True)
class GetItemInput:

    database_id: str | None = None
    key: str | None = None

@dataclass
class MetadataValueString:

    value: str

@dataclass
class MetadataValueStringArray:

    value: list[str]

@dataclass
class MetadataValueNumber:

    value: float

@dataclass
class MetadataValueNumberArray:

    value: list[float]

@dataclass
class MetadataValueUnknown:
    """Represents an unknown variant.

    If you receive this value, you will need to update your library to receive the
    parsed value.

    This value may not be deliberately sent.
    """

    tag: str

MetadataValue = Union[MetadataValueString, MetadataValueStringArray, MetadataValueNumber, MetadataValueNumberArray, MetadataValueUnknown]

@dataclass(kw_only=True)
class GetItemOutput:

    key: str

    vector: list[float]

    value: bytes | bytearray | None = None
    metadata: dict[str, MetadataValue] | None = None

@dataclass(kw_only=True)
class ListItemsInput:

    database_id: str | None = None
    page_size: int = 1000
    next_token: str | None = None

@dataclass(kw_only=True)
class Item:

    key: str

    vector: list[float]

    value: bytes | bytearray | None = None
    metadata: dict[str, MetadataValue] | None = None

@dataclass(kw_only=True)
class ListItemsOutput:

    items: list[Item]

    next_token: str | None = None

@dataclass
class QueryTypeKey:

    value: str

@dataclass
class QueryTypeVector:

    value: list[float]

@dataclass
class QueryTypeUnknown:
    """Represents an unknown variant.

    If you receive this value, you will need to update your library to receive the
    parsed value.

    This value may not be deliberately sent.
    """

    tag: str

QueryType = Union[QueryTypeKey, QueryTypeVector, QueryTypeUnknown]

@dataclass(kw_only=True)
class QueryInput:
    """
    :param filter: Optional lucene-style filter evaluated against item metadata
    during the query.
    """

    database_id: str | None = None
    max_results: int = 5
    query: QueryType | None = None
    filter: str | None = None

@dataclass(kw_only=True)
class QueryResultItem:

    key: str

    value: bytes | bytearray

    vector: list[float]

    metadata: dict[str, MetadataValue]

    distance: float

@dataclass(kw_only=True)
class QueryOutput:

    results: list[QueryResultItem]

@dataclass(kw_only=True)
class SetItemInput:

    database_id: str | None = None
    key: str | None = None
    value: bytes | bytearray | None = None
    vector: list[float] | None = None
    metadata: dict[str, MetadataValue] | None = None

@dataclass
class SetItemOutput:
    pass
